package uk.co.hcsoftware.commander;

import java.text.Collator;
import java.util.Comparator;
import java.util.logging.Logger;


/**
 * Title: NameComparator
 * Copyright:    Copyright (c) 28-Oct-2005
 *
 * @author spurlinn
 */
public class NameComparator implements Comparator<String>{
    public static final Logger log = Logger.getLogger(NameComparator.class.getName());
    final Collator[] collators = new Collator[4];
    public NameComparator() {

        for(int i=0;i<collators.length;i++){
            final Collator c= Collator.getInstance();
            switch(i){
                case 0: c.setStrength(Collator.PRIMARY); break;
                case 1: c.setStrength(Collator.SECONDARY); break;
                case 2: c.setStrength(Collator.TERTIARY); break;
                default: c.setStrength(Collator.IDENTICAL); break;
            }
            collators[i]=c;
        }
    }

    public int compare(String s, String s1) {
        int j=0;
        for (int i = 0; i < collators.length; i++) {
            Collator collator = collators[i];
            j=collator.compare(s,s1);
            if(j!=0) return j;
        }
        return j;
    }
}
