package uk.co.hcsoftware.commander;

import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;


public class StringCoder {
    private final char separatorChar;

    public StringCoder(char separatorChar) {
        this.separatorChar = separatorChar;
    }

      public String writeLine(String[] fields) {
        StringBuffer sb = new StringBuffer();
        for (int i = 0; i < fields.length; i++) {
            String field = fields[i];
            if (field!=null) {
                field = field.replaceAll("\\\\", "\\\\\\\\");
                field = field.replaceAll("\\"+separatorChar, "\\\\\\"+separatorChar);
                sb.append(field);
            }
            if (i + 1 < fields.length && fields[i+1]!=null && fields[i+1].length()>0) {
                sb.append(separatorChar);
            }
        }
        return sb.toString();
    }

    public String[] readLine(String line) {
        //first preparse the line to eliminate escapes
        line = line.replaceAll("\\\\\\\\", "\\\\");
        line = line.replaceAll("\\\\\\"+separatorChar, "\\"+separatorChar);
        //String[] fields = line.split("[^\\]?+\\+"); //need to match all + chars that are not preceded by \
        //return fields;
        List l = new LinkedList();
        char[] c = line.toCharArray();
        int prevChar = -1;
        StringBuffer field = new StringBuffer();
        for (int i = 0; i < c.length; i++) {
            char c1 = c[i];
            if (prevChar != -1 && prevChar != '\\' && c1 == separatorChar) {
                l.add(field.toString());
                field.setLength(0);
            } else {
                field.append(c1);
            }
            prevChar = c1;
        }
        if (field.length() > 0) {
            l.add(field.toString());
        }
        return (String[]) l.toArray(new String[l.size()]);
    }

    public String[] readLine2(String line) {
        //first preparse the line to eliminate escapes
        line = line.replaceAll("\\\\\\\\", "\\\\");
        line = line.replaceAll("\\\\\\"+separatorChar, "\\"+separatorChar);
        //String[] fields = line.split("[^\\]?+\\+"); //need to match all + chars that are not preceded by \
        //return fields;
        List l = new LinkedList();
        char[] c = line.toCharArray();
        int prevChar = -1;
        StringBuffer field = new StringBuffer();
        for (int i = 0; i < c.length; i++) {
            char c1 = c[i];
            if (prevChar != -1 && prevChar != '\\' && c1 == separatorChar) {
                l.add(field.toString());
                field.setLength(0);
            } else {
                field.append(c1);
            }
            prevChar = c1;
        }
        if (field.length() > 0) {
            l.add(field.toString());
        }
        return (String[]) l.toArray(new String[l.size()]);
    }

    public static void main(String[] args) {
        final StringCoder sc = new StringCoder(' ');
        final String[] fields = new String[]{"c:\\Program Files\\Java\\jdk1.5.0_06\\bin\\java.exe","-jar","c:\\t\\jEdit 4.3pre2\\jedit.jar"};
        System.out.println("fields="+Arrays.asList(fields));
        final String line = sc.writeLine(
                fields
                );
        System.out.println(line);
        System.out.println(Arrays.asList(sc.readLine2(line)));
    }
}
