package uk.co.hcsoftware.commander.gui;

import javax.swing.*;
import java.awt.*;
import java.util.logging.Logger;


/**
 * add itself to a  commandertree, and provides the functionality to jump to some row as letters are typed
 *
 * Title: AutocompleteJumper
 * Copyright:    Copyright (c) 30-Nov-2005
 *
 * @author spurlinn
 */
public class AutocompleteJumperJtable extends AutocompleteJumper {
    private static final Logger log = Logger.getLogger(AutocompleteJumperJtable.class.getName());
    private final JTable ct;

    public AutocompleteJumperJtable(JTable ct, RowIdentifier ri) {
        super(ri);
        this.ct = ct;
        ct.addKeyListener(this);
    }

    protected int getRowCount() {
        return ct.getRowCount();
    }

    protected int getSelectedRow() {
        return ct.getSelectedRow();
    }

    protected void scrollToVisible(int row) {
        final Rectangle cellRect = ct.getCellRect(row,0,true);
        log.finer("scrolltovisible cellRect="+cellRect);
        ct.scrollRectToVisible(cellRect);
    }

    protected void setSelectionInterval(int start, int end) {
        ct.getSelectionModel().setSelectionInterval(start,end);
    }
}
