package uk.co.hcsoftware.commander.gui;

import uk.co.hcsoftware.commander.CannotSaveStateException;
import uk.co.hcsoftware.commander.io.SaveTarget;

/**
 * Title: Commandule
 * Copyright:    Copyright (c) 18-Jan-2006
 *
 * @author spurlinn
 */
public interface Commandule extends SaveTarget,Cloneable{
    boolean getFocus();
    void restorePreviousState() throws CannotRestoreSavedStateException ;
    void restoreNextState()throws CannotRestoreSavedStateException;
    /**
     * //save current state to a unicode string that can be used later to restore state
     * by convention, string is preceded by a 'magic' value (e.g. the classname that saved it) which you
     * use to determine if you can restore state from that (or some other) string later
     * @return
     * @throws CannotSaveStateException
     */
    String saveState() throws CannotSaveStateException; 
    /**
     * restores state saved (for example) previously with saveState()
     * @param state
     * @throws CannotRestoreSavedStateException
     */
    void restoreState(String state) throws CannotRestoreSavedStateException;
    Commandule createClone() ;

    void delete();
    void launch();
    void mkdir();
    void move();
    void rename();
    void copy();
    void duplicate();
    void shell();
    void usercommand();
}
