package uk.co.hcsoftware.commander.gui;

import java.util.logging.Logger;
import java.util.Map;
import java.util.HashMap;
import java.util.Set;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.io.IOException;


/**
 * Title: DefaultTransferable
 * Copyright:    Copyright (c) 19-Apr-2006
 *
 * @author N Spurling
 */
public class DefaultTransferable implements Transferable{
    public static final Logger log = Logger.getLogger(DefaultTransferable.class.getName());

    private Map<DataFlavor,Object> dataMap = new HashMap<DataFlavor, Object>();

    public DefaultTransferable(DataFlavor df, Object transferData) {
        addData(df,transferData);
    }

    /**
     * I think, by convention transferData should be an instanceof DataFlavor?
     * @param df
     * @param transferData
     */
    public void addData(DataFlavor df, Object transferData){
        dataMap.put(df,transferData);
    }

    public DataFlavor[] getTransferDataFlavors() {
        final Set<DataFlavor> dataFlavors = dataMap.keySet();
        return dataFlavors.toArray(new DataFlavor[dataFlavors.size()]);
    }

    public boolean isDataFlavorSupported(DataFlavor flavor) {
        return dataMap.containsKey(flavor);
    }

    public Object getTransferData(DataFlavor flavor) throws UnsupportedFlavorException, IOException {
        if(!isDataFlavorSupported(flavor)) throw new UnsupportedFlavorException(flavor);
        return dataMap.get(flavor);
    }

}
