package uk.co.hcsoftware.commander.gui;

import javax.swing.*;
import javax.swing.text.DefaultCaret;
import java.awt.*;
import java.awt.event.*;
import java.util.ArrayList;
import java.util.logging.Logger;


public class GlassPanel extends JPanel{
    private static Logger log = Logger.getLogger(GlassPanel.class.getName());

    private final JTextArea jta;
    public GlassPanel() {
        GridBagLayout gbl = new GridBagLayout();
        setLayout(gbl);
        setOpaque(false);
        addKeyListener(new KeyAdapter() {});
        addMouseListener(new MouseAdapter(){});
        jta = createJtextArea();

        GridBagConstraints gbc = new GridBagConstraints();
        gbl.setConstraints(jta,gbc);
        add(jta);
        addFocusListener(new FocusAdapter() {
            public void focusGained(FocusEvent e) {
                log.finer("gp gained focus");
            }

            public void focusLost(FocusEvent e) {
                log.finer("gp lost focus opp="+e.getOppositeComponent());
            }
        });
    }
    public void setMessage(String message){
        jta.setText(message);
    }

    private JTextArea createJtextArea() {
        JTextArea jTextArea = new JTextArea();
        jTextArea.setEditable(false);
        jTextArea.setOpaque(true);
        jTextArea.setForeground(Color.white);
        jTextArea.setBackground(Color.black);
        jTextArea.setFont(new Font("Dialog",Font.BOLD,20));
        DefaultCaret dc = new DefaultCaret(){
            public Dimension getSize() {
                return new Dimension((int)getWidth(),(int)getHeight());
            }
            public double getWidth() {
                return 0;
            }
            public double getHeight() {
                return 0;
            }
        };
        jTextArea.setCaret(dc);
        jTextArea.setWrapStyleWord(true);
        jTextArea.setLineWrap(false);
        jTextArea.setHighlighter(null);
//        jTextArea.setFocusable(false);
        jTextArea.setEditable(false);
        jTextArea.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
        return jTextArea;
    }

    private java.util.List<KeyListener> kls=new ArrayList<KeyListener>();
    public void setKeyListener(KeyListener kl) {
        if(!kls.isEmpty()){
            for(KeyListener k:kls){
                removeKeyListener(k);
            }
        }
        if (kl!=null) {
            addKeyListener(kl);
            kls.add(kl);
        }
    }

    public void setColors(Color foreColor, Color backColor) {
        jta.setForeground(foreColor);
        jta.setBackground(backColor);
        setBackground(backColor);
        setForeground(foreColor);
    }
}
