package uk.co.hcsoftware.commander.gui;

import javax.swing.*;
import javax.swing.border.BevelBorder;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.awt.event.WindowEvent;
import java.awt.event.WindowFocusListener;
import java.io.IOException;
import java.net.URL;
import java.util.logging.Logger;
import java.util.logging.Level;


public class HtmlDialog extends JDialog {
    public static final Logger log = Logger.getLogger(HtmlDialog.class.getName());
    protected JEditorPane jep;
    protected JLabel jl;
    private JScrollPane jsp;

    public HtmlDialog(Dialog owner, String title, boolean isTransient) throws HeadlessException {
        super(owner, title, false);
        init(isTransient, owner);
    }

    public HtmlDialog(Frame owner, String title, boolean isTransient) throws HeadlessException {
        super(owner, title, false);
        init(isTransient, owner);
    }

    private void init(boolean isTransient, Component owner) {
        jep = new JEditorPane("text/html","");
        jl = new JLabel();
        super.setDefaultCloseOperation(JDialog.HIDE_ON_CLOSE);
        if (isTransient) {
            super.setUndecorated(true);
            addWindowFocusListener(new WindowFocusListener() {
                public void windowGainedFocus(WindowEvent e) { }
                public void windowLostFocus(WindowEvent e) {
                    log.info("windowLostFocus2");
                    dispose();
                }
            });
        }

        JPanel mainPan = new JPanel(new BorderLayout());
        mainPan.getInputMap().put(KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE,0),"dispose");
        mainPan.getActionMap().put("dispose",new AbstractAction() {
            public void actionPerformed(ActionEvent e) {
                dispose();
            }
        });
        mainPan.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
        getContentPane().add(mainPan);
        mainPan.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));
        jl.setBorder(BorderFactory.createEmptyBorder(3,3,3,3));
        mainPan.add(jl,BorderLayout.SOUTH);
        jep.setEditable(false);
        jsp = new JScrollPane(jep);
        mainPan.add(jsp);

        setSize(450,300);
        setLocationRelativeTo(owner);
        jep.addHyperlinkListener(new HyperlinkListener() {
            public void hyperlinkUpdate(HyperlinkEvent e) {
                if (e.getEventType()==HyperlinkEvent.EventType.ACTIVATED) {
                    if(launchUrls){
                        try {
                            final URL url = e.getURL();
                            log.fine("hyperlinked="+url);
                            fl.launchUrls(url.toString());
                        } catch (IOException e1) {
                            log.log(Level.WARNING, "exception", e1);
                        }
                    }
                }
            }
        });
    }
    FileLauncher fl = new FileLauncher();
    private boolean launchUrls=false;

    public void setLaunchUrls(boolean launchUrls) {
        this.launchUrls = launchUrls;
    }

    public void setStatusText(final String text) {
        jl.setText(text);
    }

    public void loadHtml(URL url) throws IOException {
        jep.setPage(url);
    }

    public void loadHtml(String html) {
        jep.setText(html);
//        log.finer("scrolling t vis=");
//        Rectangle visible = jsp.getVisibleRect();
//        visible.x = 0;visible.y=0;
        final Point p = new Point();
//        log.fine("setviewpos="+p);
//        jsp.getViewport().remove(jep);//removeAll();
//        jsp.getViewport().setView(jep);
        jsp.getViewport().setViewPosition(p);

    }
}
