package uk.co.hcsoftware.commander.gui;

import javax.swing.*;
import java.util.logging.Logger;
import java.util.List;
import java.util.ArrayList;


/**
 * single class that can be shared by all commanderframes (that display a statusbar) that way this class can act as a model and they
 * can all be views of the same thing (so that they stay in sync)
 *
 * Title: StatusManager
 * Copyright:    Copyright (c) 24-Apr-2006
 *
 * @author N Spurling
 */
public class StatusManager {
    public static final Logger log = Logger.getLogger(StatusManager.class.getName());
    private List<Listener> l=new ArrayList<Listener>();
    List<Action> actions=new ArrayList<Action>();
    public List<Action> getActions(){
        return actions;
    }
    public static interface Listener{
        void actionsChanged(List<Action> a);
        void mainStatusTextChanged(String newMainStatusText);
    }
    public void addListener(Listener l){
        this.l.add(l);
    }
    public void removeListener(Listener l){
        this.l.remove(l);
    }
    public void addAllFramesAction(Action a){
        actions.add(a);
        for(Listener l:new ArrayList<Listener>(this.l)){
            l.actionsChanged(actions);
        }
    }
    public void setAllFramesStatusText(String newText){
        for(Listener l:new ArrayList<Listener>(this.l)){
            l.mainStatusTextChanged(newText);
        }
    }

}
