/*
 * WaitPanel.java
 *
 * Created on 29 March 2006, 15:33
 */

package uk.co.hcsoftware.commander.gui;


import javax.swing.*;
import java.awt.event.ActionListener;
import java.awt.*;

/**
 *
 * @author  spurlinn
 */
public class WaitPanel extends javax.swing.JPanel {
    GlassPanel gp = new GlassPanel();
    private javax.swing.JButton cancelButton;
    private javax.swing.JScrollPane jsp;
    private final JPanel bPanel;

    public WaitPanel() {
        super(new BorderLayout());
        setOpaque(true);
        jsp = new javax.swing.JScrollPane();
        cancelButton = new javax.swing.JButton();
        jsp.setViewportView(gp);
        cancelButton.setText("Cancel");
        add(jsp);
        this.bPanel = new JPanel(new FlowLayout(FlowLayout.RIGHT));
        this.bPanel.add(cancelButton);
        add(this.bPanel,BorderLayout.SOUTH);
        setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
    }



    public void blockInput(String text,ActionListener onCancel){
        updateBlockedMessage(text);
        for(ActionListener al:cancelButton.getActionListeners()){
            cancelButton.removeActionListener(al);
        }
        cancelButton.setEnabled(true);
        cancelButton.addActionListener(onCancel);
        setVisible(true);
    }
    public void blockInput(String text) {
        updateBlockedMessage(text);
        cancelButton.setEnabled(false);
        setVisible(true);
    }
    public void unblockInput() {
        setVisible(false);
    }
    public void updateBlockedMessage(String fullMessage) {
        gp.setMessage(fullMessage);
    }

    public void setColors(Color foreColor, Color backColor) {
        gp.setColors(foreColor,backColor);
        setBackground(backColor);
        setForeground(foreColor);
        bPanel.setBackground(backColor);
        bPanel.setForeground(foreColor);
        jsp.getViewport().setBackground(backColor);
        jsp.getViewport().setForeground(foreColor);
    }

    public void setCancelText(String s) {
        cancelButton.setText(s);
    }
}
