package uk.co.hcsoftware.commander.gui.ctable;

import javax.swing.table.TableCellRenderer;
import java.util.Comparator;


/**
 * Title: ColumnSpec, convenient place to specify column size saving info and renderer
 * Copyright:    Copyright (c) 15-Mar-2006
 *
 * @author N Spurling
 */
public class ColumnSpec{
    private final String prefKey;
    private final int defaultWidth;
    private TableCellRenderer tcr;
    private final int modelIndex;
    private Comparator c;

    private ColumnSpec(int modelIndex, String prefKey, int defaultWidth, TableCellRenderer tcr) {
        this.modelIndex = modelIndex;
        this.prefKey = prefKey;
        this.defaultWidth = defaultWidth;
        this.tcr = tcr;
    }

    public Comparator getComparator() {
        return c;
    }

    public String toString() {
        return "modelIndex="+getModelIndex()+" prefKey="+getPrefKey();
    }

    public String getPrefKey() {
        return prefKey;
    }

    public int getDefaultWidth() {
        return defaultWidth;
    }

    public TableCellRenderer getRenderer() {
        return tcr;
    }

    public int getModelIndex() {
        return modelIndex;
    }

    public static ColumnSpec createColumnSpec(int modelIndex, String prefKey, int defaultWidth, TableCellRenderer tcr) {
        return new ColumnSpec(modelIndex, prefKey, defaultWidth, tcr);
    }
    public static ColumnSpec createColumnSpec(int modelIndex, String prefKey, int defaultWidth) {
        return new ColumnSpec(modelIndex, prefKey, defaultWidth, null);
    }
    public ColumnSpec setRenderer(TableCellRenderer tcr){
        this.tcr=tcr;
        return this;
    }
    private SortDirection defaultSortDirection=SortDirection.ascending;
    public ColumnSpec comparator(Comparator c, SortDirection sd){
        this.c=c;
        this.defaultSortDirection=sd;
        return this;
    }

    public SortDirection getDefaultSortDirection() {
        return defaultSortDirection;
    }

    public boolean hasComparator() {
        return c!=null;
    }
}
