package uk.co.hcsoftware.commander.gui.file;

import uk.co.hcsoftware.commander.io.ImageProvider;
import uk.co.hcsoftware.commander.gui.CreateFileDialogBuilder;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.io.File;
import java.io.IOException;
import java.util.Collections;
import java.util.logging.Level;
import java.util.logging.Logger;


/**
 * Title: CreateEmptyFileAction
 * Copyright:    Copyright (c) 13-Feb-2006
 *
 * @author spurlinn
 */
public class CreateEmptyFileAction extends AbstractAction {
     private static final Logger log = Logger.getLogger(CreateEmptyFileAction.class.getName());
    private static final String title="Create empty file";
    private DirectoryPanel directoryPanel;

    public CreateEmptyFileAction(DirectoryPanel directoryPanel) {
        super(title, ImageProvider.getInstance().getIcon("icons/16/filenew.png"));
        this.directoryPanel = directoryPanel;
    }

    public void actionPerformed(ActionEvent e) {
        Vfile vf = directoryPanel.getDirectory();
        if (vf!=null) {
            File parentDir=vf.getFile();
//            String dest=(String)JOptionPane.showInputDialog(directoryPanel,
//                    title
//                    ,"Enter Name for file:",JOptionPane.QUESTION_MESSAGE,null
//                    ,null,"");
            File dest = new CreateFileDialogBuilder()
                    .withTitle(title)
                    .withMessage("Create empty file:")
                .showDialogForFile(directoryPanel,parentDir);
            if(dest!=null /*&& dest.trim().length()>0*/){
                try {
                    File f = dest;//new File(parentDir,dest);
                    if(f.exists()){
                        JOptionPane.showMessageDialog(directoryPanel,"That name is already in use!",title,JOptionPane.ERROR_MESSAGE);
                        return;
                    }
                    if(f.createNewFile()){
                        directoryPanel.fem.fireAdded(f);
                        directoryPanel.selectFiles(Collections.singletonList(f));
                    }
                    else{
                        JOptionPane.showMessageDialog(directoryPanel,"Couldn't create new file"
                                ,title,JOptionPane.ERROR_MESSAGE);
                    }
                } catch (IOException e1) {
                    log.log(Level.WARNING, "exception", e1);
                    JOptionPane.showMessageDialog(directoryPanel,"Couldn't create new file\n" +
                            "["+e1.getMessage()+"]",title,JOptionPane.ERROR_MESSAGE);
                }
            }
            else log.fine("ignoring "+title+" as null name entered");
        }
        else log.fine("ignoring "+title+" as parentdir is null");
    }
}
