package uk.co.hcsoftware.commander.gui.file;

import uk.co.hcsoftware.commander.io.FileUtils;

import java.io.File;
import java.util.Collections;
import java.util.List;
import java.util.logging.Logger;

public final class FilesChangedEvent {
    private static final Logger log = Logger.getLogger(FilesChangedEvent.class.getName());
    private final List<File> deleted,added,changed;

    public FilesChangedEvent(List<File> deleted, List<File> added, List<File> changed) {
        List<File> empty = Collections.emptyList();
        this.deleted = deleted==null?empty:deleted;
        this.added = added==null?empty:added;
        this.changed = changed==null?empty:changed;
    }

    public List<File> getDeleted() {
        return deleted;
    }

    public List<File> getAdded() {
        return added;
    }

    public List<File> getChanged() {
        return changed;
    }

    public List<File> getDeleted(File parent) {
        return FileUtils.getInstance().findFilesWithThisParent(deleted,parent);
    }

    public List<File> getAdded(File parent) {
        return FileUtils.getInstance().findFilesWithThisParent(added,parent);
    }

    public List<File> getChanged(File parent) {
        return FileUtils.getInstance().findFilesWithThisParent(changed,parent);
    }

    public String toString() {
        return "added="+added+" deleted="+deleted+" changed="+changed;
    }


}
