package uk.co.hcsoftware.commander.gui.file;

import uk.co.hcsoftware.commander.gui.InputBlocker;
import uk.co.hcsoftware.commander.io.FileEventManager;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.io.File;
import java.util.Collections;
import java.util.List;
import java.util.logging.Logger;


/**
 * Title: DeleteAction
 * Copyright:    Copyright (c) 01-Mar-2006
 *
 * @author N Spurling
 */
public class RenameAction extends AbstractAction{
    public static final Logger log = Logger.getLogger(RenameAction.class.getName());

    private final Component host;
    private InputBlocker inputBlocker;
    private final FileSelector fs;

    public RenameAction(Component host, InputBlocker directoryPanel, FileSelector fs) {
        this.host = host;
        this.inputBlocker = directoryPanel;
        this.fs = fs;
    }

    public void actionPerformed(ActionEvent e) {
        List<File> selected = fs.getSelectedFiles(true,true,false);
        if(selected.isEmpty()) return;
        if(selected.size()==1){
            File sourceFile=selected.get(0);
            String dest=(String)JOptionPane.showInputDialog(host,
                    "rename "+sourceFile.getName()+" to:"
                    ,"Rename",JOptionPane.QUESTION_MESSAGE,null
                    ,null,sourceFile.getName());
            if(dest!=null){
                File destinationFile=new File(sourceFile.getParentFile(),dest);

                //check the vfile doesn't exist
                if(destinationFile.exists()){
                    JOptionPane.showMessageDialog(host
                            ,"destination file "+destinationFile.getName()+" already exists!"
                            ,"Rename"
                            ,JOptionPane.ERROR_MESSAGE);
                }
                else if(sourceFile.equals(destinationFile)){
                    JOptionPane.showMessageDialog(host
                            ,"Couldn't rename "+sourceFile.getName()+"\n Sourcefile and destination file are the same!"
                            ,"Rename"
                            ,JOptionPane.ERROR_MESSAGE);
                }
                else{
                    if(sourceFile.renameTo(destinationFile)) {
                        FileEventManager.getInstance().fireEvent(Collections.singletonList(sourceFile)
                                ,Collections.singletonList(destinationFile)
                                ,null);
                        fs.selectFiles(Collections.singletonList(destinationFile));
                    } else{
                        JOptionPane.showMessageDialog(host
                                ,"Couldn't rename "+sourceFile.getName()
                                ,"Rename"
                                ,JOptionPane.ERROR_MESSAGE);
                    }
                }
            }
        }
        else  JOptionPane.showMessageDialog(host
                ,"Cannot rename: must select 1 file"
                ,"Rename"
                ,JOptionPane.ERROR_MESSAGE);

    }
}
