package uk.co.hcsoftware.commander.gui.zip;

import java.io.File;


/**
 * Title: CannotOpenZipException
 * Copyright:    Copyright (c) 24-Jan-2006
 *
 * @author spurlinn
 */
public class CannotOpenZipException extends Exception {
    private File zipFile;
    private String path;

    public CannotOpenZipException(File zipFile, String path, String message) {
        super(message);
        this.zipFile = zipFile;
        this.path = path;
    }

    public CannotOpenZipException(File zipFile, String path, String message, Throwable cause) {
        super(message, cause);
        this.zipFile = zipFile;
        this.path = path;
    }

    public File getZipFile() {
        return zipFile;
    }

    public String getPath() {
        return path;
    }
}
