package uk.co.hcsoftware.commander.gui.zip;

import uk.co.hcsoftware.commander.io.treestream.Node;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.logging.Logger;
import java.util.zip.ZipFile;


/**
 * Title: ZipFileStreamNode
 * Copyright:    Copyright (c) 08-Feb-2006
 *
 * @author spurlinn
 */
class ZipFileStreamNode implements Node {
    private static final Logger log = Logger.getLogger(ZipFileStreamNode.class.getName());
    private ZipFile zf;
    private ZipNode ze;
    public ZipFileStreamNode(ZipFile zf, ZipNode ze) {
        this.zf = zf;
        this.ze = ze;
    }

    public String getName() {
        return ze.getName();
    }

    public List<Node> getChildren() {
        if(ze.isDirectory()){
            List<Node> l = new ArrayList<Node>(ze.getChildren().size());
            for(ZipNode child:ze.getChildren()) l.add(new ZipFileStreamNode(zf,child));
            return l;
        }
        else return Collections.emptyList();
    }

    public boolean hasInputStream() {
        return ze.hasEntry() && !ze.isDirectory();
    }

    public InputStream getInputStream() throws IOException {
        if(hasInputStream()){
            return ze.getInputStream(zf);
        }
        return null;
    }

}
