/* ----------------------------------------------------------------
 * FILENAME    : ${NAME}
 * DESCRIPTION : 
 *               
 *
 * PROJECT     : stockconfig
 *
 * PROGRAMMER  : spurln
 *
 * COPYRIGHT   : Copyright (c) 2004 - The Goldman, Sachs Group, Inc.
 *                               All rights reserved
 *
 * Source      : $Source: 
 * Revision    : $Revision: 
 * Last Changed: $Date: 
 * ---------------------------------------------------------------- */
package uk.co.hcsoftware.commander.io;

import javax.swing.*;
import java.awt.*;
import java.net.URL;
import java.util.HashMap;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;

public class ImageProvider {
    private static Logger log = Logger.getLogger(ImageProvider.class.getName());

    private static ImageProvider ourInstance = new ImageProvider();

    public static ImageProvider getInstance() {
        return ourInstance;
    }

    private ImageProvider() {
    }
    private Map<String,ImageIcon> cache=new HashMap<String, ImageIcon>();
    public ImageIcon getIcon(String name){
        try {
            if (!cache.containsKey(name)) {
                final URL systemResource =  ImageProvider.class.getClassLoader().getResource(name);
                cache.put(name,new ImageIcon(systemResource));
            }
            return cache.get(name);
        } catch (Exception e) {
            log.log(Level.WARNING,"couldn'updateProgressTimer load image name="+name,e);
            return null;
        }
    }
    public Image getImage(String name){
        ImageIcon ii = getIcon(name);
        if(ii==null) return null;
        return ii.getImage();
    }
}
