package uk.co.hcsoftware.commander.io.treestream;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Collections;
import java.util.List;
import java.util.logging.Logger;


/**
 * Title: BytesNode
 * Copyright:    Copyright (c) 07-Feb-2006
 *
 * @author spurlinn
 */
public class BytesNode implements Node {
    public static final Logger log = Logger.getLogger(BytesNode.class.getName());
    private final String name;
    private byte[] bytes;

    public BytesNode(String name,byte[] bytes) {
        this.name = name;
        this.bytes = bytes;
    }

    public String getName() {
        return name;
    }

    public List<Node> getChildren() {
        return Collections.emptyList();
    }

    public boolean hasInputStream() {
        return true;
    }

    public InputStream getInputStream() throws IOException {
        return new ByteArrayInputStream(bytes);
    }

}
