package uk.co.hcsoftware.commander.io.treestream;

import java.util.List;
import java.util.Collections;
import java.util.ArrayList;
import java.util.Arrays;
import java.io.InputStream;
import java.io.IOException;

/**
 * $Log: DefaultNode.java,v $
 * Revision 1.1  2006/12/10 12:01:44  ns
 * update to 3-nov-2006 version
 *
 */
public class DefaultNode implements Node{
    private List<Node> children=new ArrayList<Node>();
    private String name;

    public DefaultNode(String name, Node... children) {
        this.name = name;
        this.children.addAll(Arrays.asList(children));
    }

    public void addChild(Node child){
        children.add(child);
    }

    public String getName() {
        return name;
    }

    public List<Node> getChildren() {
        return children;
    }

    public boolean hasInputStream() {
        return false;
    }

    public InputStream getInputStream() throws IOException {
        return null;
    }

    public Node getChild(String name) {
        for(Node child:children){
            if(child.getName().equals(name)) return child;
        }
        return null;
    }
}
