package uk.co.hcsoftware.commander.io.treestream;

import java.util.List;
import java.io.InputStream;
import java.io.IOException;

/**
 * $Log: Node.java,v $
 * Revision 1.1  2006/12/10 12:01:44  ns
 * update to 3-nov-2006 version
 *
 */
public interface Node {
    /**
     * name of this particular node, should be unique wrt its siblings
     * @return
     */
    String getName();
    /**
     *
     * @return immediate children of this node (if is a leaf return an empty list)
     */
    List<Node> getChildren();
    boolean hasInputStream();
    /**
     *
     * @return may be null; inputstream for this node (if it is a leaf) otherwise null; in which case it is a directory
     * and has 0 or more children. There is no provision for directories that have inputstreams or leaves which don'updateProgressTimer have inputstreams
     */
    InputStream getInputStream() throws IOException;

}
