package uk.co.hcsoftware.commander.prefs;

import javax.swing.*;
import java.util.prefs.PreferenceChangeEvent;
import java.util.prefs.Preferences;


/**
 * Title: BooleanPref
 * Copyright:    Copyright (c) 08-Mar-2006
 *
 * @author N Spurling
 */
public class BooleanPref {
    private JCheckBox jcb;
    private Preferences prefs;
    private String prefKey;
    private final boolean defaultValue;

    public BooleanPref(Preferences prefs, String prefKey, boolean defaultValue) {
        this.prefs = prefs;
        this.prefKey = prefKey;
        this.defaultValue = defaultValue;

    }
    public void bindCheckBox(JCheckBox jcb){
        this.jcb = jcb;
        jcb.setSelected(getValue());
    }
    public void applyIfNecessary(){
        if (jcb!=null) {
            boolean userValue=jcb.isSelected();
            boolean prefsValue = getValue();
            if(userValue!=prefsValue){
                prefs.putBoolean(prefKey,userValue);
            }
        }
    }
    public boolean getValue() {
        return prefs.getBoolean(prefKey,defaultValue);
    }

    public boolean isThisPref(PreferenceChangeEvent evt) {
        return evt.getNode().equals(prefs) && prefKey.equals(evt.getKey());
    }

    public Preferences getPrefs() {
        return prefs;
    }

}
