/*
 * GeneralConfigPanel.java
 *
 * Created on 08 March 2006, 13:12
 */

package uk.co.hcsoftware.commander.prefs;

import uk.co.hcsoftware.commander.io.FileUtils;
import uk.co.hcsoftware.commander.Main;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.logging.Logger;
import java.util.logging.Level;
import java.util.prefs.Preferences;

/**
 *
 * @author  spurlinn
 */
public class GeneralConfigPanel extends javax.swing.JPanel implements PrefsTab{
    private static final Logger log = Logger.getLogger(GeneralConfigPanel.class.getName());
    private static final Preferences prefs = Preferences.userNodeForPackage(GeneralConfigPanel.class);
    private static final Preferences prefs1 = Preferences.userNodeForPackage(Main.class);

    /**
     * Creates new form GeneralConfigPanel
     */
    public GeneralConfigPanel() {
        initComponents();
        loadPrefs();

        chooseTempFolder.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                try {
                    JFileChooser jfc = new JFileChooser();
                    jfc.setDialogTitle("Select a folder for trash");
                    jfc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
                    if(jfc.showDialog(GeneralConfigPanel.this, "Trash folder") ==JFileChooser.APPROVE_OPTION){
                        trashFolderTextfield.setText(jfc.getSelectedFile().getAbsolutePath());
                    }
                } catch (Exception e1) {
                     log.log(Level.WARNING,"exception",e1);
                }
            }
        });
        defaultButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
               setTrashEnable();
            }
        });
    }


    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        showViewControls = new javax.swing.JCheckBox();
        showCommanderButtons = new javax.swing.JCheckBox();
        jLabel1 = new javax.swing.JLabel();
        helpText = new javax.swing.JTextArea();
        chooseTempFolder = new javax.swing.JButton();
        defaultButton = new javax.swing.JCheckBox();
        jScrollPane1 = new javax.swing.JScrollPane();
        trashFolderTextfield = new javax.swing.JTextField();

        showViewControls.setSelected(true);
        showViewControls.setText("Show view controls");
        showViewControls.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        showViewControls.setMargin(new java.awt.Insets(0, 0, 0, 0));

        showCommanderButtons.setSelected(true);
        showCommanderButtons.setText("Show commander buttons");
        showCommanderButtons.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        showCommanderButtons.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jLabel1.setText("'Trash' folder:");

        helpText.setBackground(new java.awt.Color(255, 255, 204));
        helpText.setColumns(20);
        helpText.setEditable(false);
        helpText.setFont(new java.awt.Font("Dialog", 0, 10));
        helpText.setLineWrap(true);
        helpText.setRows(5);
        helpText.setText("On a 'soft delete' files will be moved to this folder instead of being permanently removed.\n\nLater if you change your mind you can have a look here for them.\nIncidentally, on Mac OS X the /tmp folder is cleared each time the system restarts.");
        helpText.setWrapStyleWord(true);
        helpText.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createEtchedBorder(), javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1)));
        helpText.setDisabledTextColor(new java.awt.Color(0, 0, 0));
        helpText.setFocusable(false);
        helpText.setRequestFocusEnabled(false);

        chooseTempFolder.setText("Choose..");

        defaultButton.setText("use default");
        defaultButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        defaultButton.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jScrollPane1.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
        jScrollPane1.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_NEVER);
        jScrollPane1.setViewportView(trashFolderTextfield);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .addContainerGap()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(showCommanderButtons)
                            .add(showViewControls))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 175, Short.MAX_VALUE))
                    .add(layout.createSequentialGroup()
                        .addContainerGap()
                        .add(jLabel1))
                    .add(layout.createSequentialGroup()
                        .add(38, 38, 38)
                        .add(defaultButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 217, Short.MAX_VALUE))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(38, 38, 38)
                        .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 288, Short.MAX_VALUE))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .addContainerGap(243, Short.MAX_VALUE)
                        .add(chooseTempFolder, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 83, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(38, 38, 38)
                        .add(helpText, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 288, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(27, 27, 27)
                .add(showCommanderButtons)
                .add(20, 20, 20)
                .add(showViewControls)
                .add(21, 21, 21)
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(defaultButton)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(chooseTempFolder)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(helpText, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 118, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(148, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton chooseTempFolder;
    private javax.swing.JCheckBox defaultButton;
    private javax.swing.JTextArea helpText;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JCheckBox showCommanderButtons;
    private javax.swing.JCheckBox showViewControls;
    private javax.swing.JTextField trashFolderTextfield;
    // End of variables declaration//GEN-END:variables


    public Component getComponent() {
        return this;
    }

    public void apply() {
        showViewControlsPref.applyIfNecessary();
        showCommanderButtonsPref.applyIfNecessary();
        boolean defaultTrashDir = defaultButton.isSelected();
        prefs1.putBoolean("defaultSoftDeleteDir",defaultTrashDir);
        if (!defaultTrashDir) {
            prefs1.put("softDeleteDir",trashFolderTextfield.getText());
        } else {
            prefs1.remove("softDeleteDir");
        }
    }

    private void loadPrefs() {
        showViewControlsPref.bindCheckBox(showViewControls);
        showCommanderButtonsPref.bindCheckBox(showCommanderButtons);
        trashFolderTextfield.setText(prefs1.get("softDeleteDir", FileUtils.defaultTrashDir().getAbsolutePath()));
        defaultButton.setSelected(prefs1.getBoolean("defaultSoftDeleteDir",true));
        setTrashEnable();
    }
    public String getName() {
        return "General";
    }
    public static BooleanPref showViewControlsPref=new BooleanPref(prefs,"show_view_controls",true);
    public static BooleanPref showCommanderButtonsPref=new BooleanPref(prefs,"show_commander_buttons",true);

    private void setTrashEnable(){
        final boolean enable = !defaultButton.isSelected();
        trashFolderTextfield.setEditable(enable);
        chooseTempFolder.setEnabled(enable);
    }

}
