/*
 * UpdatePanel.java
 *
 * Created on 21 April 2006, 10:05
 */

package uk.co.hcsoftware.commander.prefs;

import uk.co.hcsoftware.commander.io.UpdateChecker;
import uk.co.hcsoftware.commander.gui.CommanderFrame;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.logging.Logger;
import java.util.prefs.Preferences;

/**
 *
 * @author  ns
 */
public class UpdatesPanel extends javax.swing.JPanel implements PrefsTab{
    private static final Logger log = Logger.getLogger(UpdatesPanel.class.getName());
    private static final Preferences prefs = Preferences.userNodeForPackage(UpdatesPanel.class);

    public UpdatesPanel() {
        initComponents();
        //load data
        resetData();
        changed=false;
        final ActionListener ableListener = new ActionListener(){
                    public void actionPerformed(ActionEvent e) {
                         able();
                    }
                };
        directConnection.addActionListener(ableListener);
        useProxy.addActionListener(ableListener) ;

        ActionListener changeListener = new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                changed = true;
            }
        };
        for(JTextField jc:new JTextField[]{proxyHost,port, userName, password}){
            jc.addActionListener(changeListener);
        }
        checkForUpates.addActionListener(changeListener);

        reset.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                resetData();
                able();
            }
        });
        checkNow.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                final CommanderFrame commanderframe = getCommanderframe();
                log.fine("cf="+commanderframe);
                new UpdateChecker().checkNow(commanderframe, true);
            }
        });
    }
    private void able(){
        able(useProxy.isSelected(),
                proxyHost,port, userName, password
                ,jLabel1,jLabel2,jLabel3,jLabel4
        );
    }
    private CommanderFrame getCommanderframe(){
        Component c=this,parent;
        while((parent=c.getParent())!=null){
            if(parent instanceof CommanderFrame) return (CommanderFrame) parent;
            c=parent;
        }
        return null;
    }
    private void resetData() {
//        checkForUpates.setSelected(false);
        checkForUpates.setSelected(prefs.getBoolean("checkForUpates",true));

        useProxy.setSelected(prefs.getBoolean("useProxy",false));
        //don't need to set directConn, as is in radiogroup with useProxy
        proxyHost.setText(prefs.get("proxyHost",""));
        port.setText(prefs.get("proxyPort",""));
        userName.setText(prefs.get("proxyUser",""));
        password.setText(prefs.get("proxyPass",""));
    }

    private void able(boolean enable, JComponent... comps){
        changed=true;
        for(JComponent jc:comps){
            jc.setEnabled(enable);
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        connectionGroup = new javax.swing.ButtonGroup();
        checkForUpates = new javax.swing.JCheckBox();
        directConnection = new javax.swing.JRadioButton();
        useProxy = new javax.swing.JRadioButton();
        jLabel1 = new javax.swing.JLabel();
        proxyHost = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        port = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        userName = new javax.swing.JTextField();
        password = new javax.swing.JPasswordField();
        checkNow = new javax.swing.JButton();
        reset = new javax.swing.JButton();

        checkForUpates.setText("Automatically check for updates");
        checkForUpates.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        checkForUpates.setMargin(new java.awt.Insets(0, 0, 0, 0));

        connectionGroup.add(directConnection);
        directConnection.setSelected(true);
        directConnection.setText("Direct connection to the Internet");
        directConnection.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        directConnection.setMargin(new java.awt.Insets(0, 0, 0, 0));

        connectionGroup.add(useProxy);
        useProxy.setText("Use proxy:");
        useProxy.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        useProxy.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jLabel1.setText("HTTP Proxy:");

        jLabel2.setText("Port:");

        port.setText("8080");

        jLabel3.setText("Username:");

        jLabel4.setText("Password:");

        checkNow.setText("Check now..");

        reset.setText("reset");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .addContainerGap()
                        .add(checkForUpates))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(20, 20, 20)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(directConnection)
                            .add(useProxy))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 119, Short.MAX_VALUE))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(33, 33, 33)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jLabel2)
                                    .add(jLabel1))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED))
                            .add(jLabel3)
                            .add(jLabel4))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 16, Short.MAX_VALUE)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                            .add(password)
                            .add(userName)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                                .add(port, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 39, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(166, 166, 166))
                            .add(org.jdesktop.layout.GroupLayout.LEADING, proxyHost)))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .addContainerGap()
                        .add(reset)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(checkNow)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(25, 25, 25)
                .add(checkForUpates)
                .add(18, 18, 18)
                .add(directConnection)
                .add(16, 16, 16)
                .add(useProxy)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(proxyHost, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2)
                    .add(port, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(14, 14, 14)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel3)
                    .add(userName, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel4)
                    .add(password, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(15, 15, 15)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(checkNow)
                    .add(reset))
                .addContainerGap(205, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox checkForUpates;
    private javax.swing.JButton checkNow;
    private javax.swing.ButtonGroup connectionGroup;
    private javax.swing.JRadioButton directConnection;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPasswordField password;
    private javax.swing.JTextField port;
    private javax.swing.JTextField proxyHost;
    private javax.swing.JButton reset;
    private javax.swing.JRadioButton useProxy;
    private javax.swing.JTextField userName;
    // End of variables declaration//GEN-END:variables



     public String getName() {
        return "Updates";
    }

    public Component getComponent() {
        return this;
    }
    boolean changed=true;
    public void apply() {
         // write prefs
        if (changed) {
            prefs.putBoolean("checkForUpates",checkForUpates.isSelected());
            prefs.putBoolean("useProxy",useProxy.isSelected());

            prefs.put("proxyHost",proxyHost.getText());
            prefs.put("proxyPort",port.getText());

            prefs.put("proxyHost",proxyHost.getText());
            prefs.put("proxyUser",userName.getText());
            prefs.put("proxyPass",new String(password.getPassword()));
        }
        else log.fine("not saving as nothign changed");
    }

}
