/*
 * ViewConfigPanel.java
 *
 * Created on 08 March 2006, 13:12
 */

package uk.co.hcsoftware.commander.prefs;

import java.awt.*;
import java.util.logging.Logger;
import java.util.prefs.Preferences;

/**
 *
 * @author  spurlinn
 */
public class ViewConfigPanel extends javax.swing.JPanel implements PrefsTab{
    private static final Logger log = Logger.getLogger(ViewConfigPanel.class.getName());
    private static final Preferences prefs = Preferences.userNodeForPackage(ViewConfigPanel.class);

    /** Creates new form ViewConfigPanel */
    public ViewConfigPanel() {
        initComponents();
        loadPrefs();
    }


    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        showViewControls = new javax.swing.JCheckBox();
        showCommanderButtons = new javax.swing.JCheckBox();

        showViewControls.setSelected(true);
        showViewControls.setText("Show view controls");
        showViewControls.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        showViewControls.setMargin(new java.awt.Insets(0, 0, 0, 0));

        showCommanderButtons.setSelected(true);
        showCommanderButtons.setText("Show commander buttons");
        showCommanderButtons.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        showCommanderButtons.setMargin(new java.awt.Insets(0, 0, 0, 0));

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(29, 29, 29)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(showCommanderButtons)
                    .add(showViewControls))
                .add(63, 63, 63))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(54, 54, 54)
                .add(showCommanderButtons)
                .add(20, 20, 20)
                .add(showViewControls)
                .addContainerGap(259, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox showCommanderButtons;
    private javax.swing.JCheckBox showViewControls;
    // End of variables declaration//GEN-END:variables


    public Component getComponent() {
        return this;
    }

    public void apply() {
        showViewControlsPref.applyIfNecessary();
        showCommanderButtonsPref.applyIfNecessary();
    }

    private void loadPrefs() {
        showViewControlsPref.bindCheckBox(showViewControls);
        showCommanderButtonsPref.bindCheckBox(showCommanderButtons);
    }
    public String getName() {
        return "View";
    }
    public static BooleanPref showViewControlsPref=new BooleanPref(prefs,"show_view_controls",true);
    public static BooleanPref showCommanderButtonsPref=new BooleanPref(prefs,"show_commander_buttons",true);


}
