package uk.co.hcsoftware.commander.test;

import junit.framework.TestCase;

import java.math.BigInteger;
import java.util.Random;


/**
 * Title: TestByteConvert
 * Copyright:    Copyright (c) 15-Feb-2006
 *
 * @author N Spurling
 */
public class TestByteConvert extends TestCase{
    private static final String[] lookup= new String[]{"0","1","2","3","4","5","6","7","8","9","a","b","c","d","e","f"};
    public void testConvert(){
        System.out.println(Integer.toHexString(Byte.MAX_VALUE));
        assertEquals("f0a0e7f",toHexString(new byte[]{0xf,0xa,0xe,0x7f}));
    }
    public void test1(){
        int i=123;
        byte[] d = intToDWord(i);
        int j = toInt(d,0);
        assertEquals(i,j);
    }


    private byte[] intToDWord(int i) {
        return new BigInteger(String.valueOf(i)).toByteArray();
//		byte[] dword = new byte[4];
//		dword[0] = (byte) ((i >> 24) & 0x000000FF);
//		dword[1] = (byte) ((i >> 16) & 0x000000FF);
//		dword[2] = (byte) ((i >> 8) & 0x000000FF);
//		dword[3] = (byte) (i & 0x00FF);
//		return dword;
	}
    Random r = new Random();
    public void testToInt(){
        for(int i=0;i<10000;i++){
            byte bytes[] =new byte[4];
            r.nextBytes(bytes);
            BigInteger bi = new BigInteger(bytes);
            final int expected = bi.intValue();

            final int actual = toInt(bytes,0);
            if(actual<0) continue;
            assertEquals("iteration="+i,expected,actual);
        }
    }
    private int toInt(byte[] bytes, int off){
//       BigInteger bi = new BigInteger(bytes);
//        return bi.intValue();
        int i=0;
        i|=bytes[off+0]<<24;
        i|=bytes[off+1]<<16;
        i|=bytes[off+2]<<8;
        i|=bytes[off+3]<<0;
        return i;
    }
    private String toHexString(byte[] bytes){
        StringBuilder sbb=new StringBuilder(bytes.length);
//        BigInteger bi = new BigInteger(bytes);
//        String s = bi.toString(16);            // 120ff0
//        if (s.length() % 2 != 0) {
//            // Pad with 0
//            s = "0"+s;
//        }
//        if(true) return s;
        for(int i=0;i<bytes.length;i+=4){

            int j = toInt(bytes,i);
            final String hex = Integer.toHexString(j);
            System.out.println("j = " + j+" hex="+hex);

            sbb.append(hex);
        }
        //for(byte b:bytes) sbb.append(lookup[b]);
        return sbb.toString();
    }
}
